function dashboard_widget (instance, widget) {
    "use strict";

    var widgets = widget;
    var InstalledModule = 0;
    

    widget.DashboardWidget = instance.Widget.extend({
        template: 'DashboardTmpl',
        widgets: [
            {
                title: 'Clientes',
                name: 'CustomerCounterWidget'
            }
        ],

        grid: {},
        start: function () {
            this.$el.find('.grid-stack.dashboard').gridstack({
                animate: true,
            });
            this.grid = this.$el.find('.grid-stack.dashboard').data('gridstack');
            this.renderWidgets();
        },
        renderWidgets: function () { 
            var self = this; 
            var wExpiredAccount = new widgets.ExpiredAccountCountersWidget(self);          
            wExpiredAccount.fecthIrModuleModule().then(function(modules){
                return modules;
            }).then(function(modules){
                if(modules.length == 0){
                    // Cliente con Saldo Vencido
                    wExpiredAccount.renderElement();
                    wExpiredAccount.start();
                    self.grid.addWidget(wExpiredAccount.$el, 0, 0, wExpiredAccount.size.width,  wExpiredAccount.size.height, true);
                    // Cliente a Cobrar hoy
                    var wExpiredAccountNow = new widgets.ExpiredAccountCountersNowWidget(self);
                    wExpiredAccountNow.renderElement();
                    wExpiredAccountNow.start();
                    self.grid.addWidget(wExpiredAccountNow.$el, 0, 0, wExpiredAccountNow.size.width,  wExpiredAccountNow.size.height, true);
                    // Cobros de Hoy
                    var wVocuherToday = new widgets.VoucherTodayCountersWidget(self);
                    wVocuherToday.renderElement();
                    wVocuherToday.start();
                    self.grid.addWidget(wVocuherToday.$el, 0, 0, wVocuherToday.size.width,  wVocuherToday.size.height, true);
                    // Cantidad de Facturas Realizada en el dia
                    var wInvoiceToday = new widgets.InvoiceTodayCountersWidget(self);
                    wInvoiceToday.renderElement();
                    wInvoiceToday.start();
                    self.grid.addWidget(wInvoiceToday.$el, 0, 0, wInvoiceToday.size.width,  wInvoiceToday.size.height, true);
                    //Ranking de Ventas de Producto por Mes
                    var wRankingProduct = new widgets.RankingSalesProductWidget(self);
                    wRankingProduct.renderElement();
                    wRankingProduct.start();
                    self.grid.addWidget(wRankingProduct.$el, 0, 0, wRankingProduct.size.width,  wRankingProduct.size.height, true);
                    //Ranking de clientes que mas compra
                    var wRankingPartner = new widgets.RankingSalesPartnerWidget(self);
                    wRankingPartner.renderElement();
                    wRankingPartner.start();
                    self.grid.addWidget(wRankingPartner.$el, 0, 0, wRankingPartner.size.width,  wRankingPartner.size.height, true);
                    //Gasto por Mes
                    var wMonthlyExpenses = new widgets.MonthlyExpensesWidget(self);
                    wMonthlyExpenses.renderElement();
                    wMonthlyExpenses.start();
                    self.grid.addWidget(wMonthlyExpenses.$el, 0, 0, wMonthlyExpenses.size.width,  wMonthlyExpenses.size.height, true);
                    //Compras por Mes
                    var wMonthlyPurchases = new widgets.MonthlyPurchasesWidget(self);
                    wMonthlyPurchases.renderElement();
                    wMonthlyPurchases.start();
                    self.grid.addWidget(wMonthlyPurchases.$el, 0, 0, wMonthlyPurchases.size.width,  wMonthlyPurchases.size.height, true);
                    //Cantidad de Prodcutos Faltantes
                    var wMissingProduct = new widgets.MissingProductWidget(self);
                    wMissingProduct.renderElement();
                    wMissingProduct.start();
                    self.grid.addWidget(wMissingProduct.$el, 0, 0, wMissingProduct.size.width,  wMissingProduct.size.height, true);
                    // Pagos de  Hoy
                    var wPaymentsToday = new widgets.PaymentsTodayCountersWidget(self);
                    wPaymentsToday.renderElement();
                    wPaymentsToday.start();
                    self.grid.addWidget(wPaymentsToday.$el, 0, 0, wPaymentsToday.size.width,  wPaymentsToday.size.height, true);
                }else{
                    // Pedidos de Hoy - Point Of Sale
                    var wPosOrderToday = new widgets.PosOrderTodayCountersWidget(self);
                    wPosOrderToday.renderElement();
                    wPosOrderToday.start();
                    self.grid.addWidget(wPosOrderToday.$el, 0, 0, wPosOrderToday.size.width,  wPosOrderToday.size.height, true); 
                    //Gasto por Mes
                    var wMonthlyExpenses = new widgets.MonthlyExpensesWidget(self);
                    wMonthlyExpenses.renderElement();
                    wMonthlyExpenses.start();
                    self.grid.addWidget(wMonthlyExpenses.$el, 0, 0, wMonthlyExpenses.size.width,  wMonthlyExpenses.size.height, true);
                    //Compras por Mes
                    var wMonthlyPurchases = new widgets.MonthlyPurchasesWidget(self);
                    wMonthlyPurchases.renderElement();
                    wMonthlyPurchases.start();
                    self.grid.addWidget(wMonthlyPurchases.$el, 0, 0, wMonthlyPurchases.size.width,  wMonthlyPurchases.size.height, true);
                    // Pagos de  Hoy
                    var wPaymentsToday = new widgets.PaymentsTodayCountersWidget(self);
                    wPaymentsToday.renderElement();
                    wPaymentsToday.start();
                    self.grid.addWidget(wPaymentsToday.$el, 0, 0, wPaymentsToday.size.width,  wPaymentsToday.size.height, true);
                    // Ranking de clientes que mas compran - Point Of Sale
                    var wRankingPosOrderPartner = new widgets.RankingPosOrdersPartnerWidget(self);
                    wRankingPosOrderPartner.renderElement();
                    wRankingPosOrderPartner.start();
                    self.grid.addWidget(wRankingPosOrderPartner.$el, 0, 0, wRankingPosOrderPartner.size.width,  wRankingPosOrderPartner.size.height, true);
                    //Ranking de Ventas de Producto por Mes - Point Of Sale
                    var wRankingPosOrderProduct = new widgets.RankingPosOrdersProductWidget(self);
                    wRankingPosOrderProduct.renderElement();
                    wRankingPosOrderProduct.start();
                    self.grid.addWidget(wRankingPosOrderProduct.$el, 0, 0, wRankingPosOrderProduct.size.width,  wRankingPosOrderProduct.size.height, true);
                }
            }); 
        }
    });
}
